﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx.Combat.CombatRoutine;
using Styx;
using Styx.WoWInternals.WoWObjects;
using Styx.Logic.Combat;
using Styx.Helpers;
using System.Drawing;
using Styx.WoWInternals;
using Styx.Logic.POI;

namespace Arma_Bellator
{
    public partial class Classname : CombatRoutine
    {
        #region CC Break
        public bool BerserkerRageCCBreak()
        {
            using (new FrameLock())
            {
                if (AB_Settings.Instance.MO_BR && AmIFeared())
                {
                    CastSpell("Berserker Rage");
                    return true;
                }
                return false;
            }
        }
        public bool BladestormCCBreak()
        {
            using (new FrameLock())
            {
                if (AB_Settings.Instance.MO_BS && AmIRooted())
                {
                    CastSpell("BladeStorm");
                    return true;
                }
                return false;
            }
        }
        #endregion

        #region Combat Buff
        public bool CombatBattleShout()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.Auras.ContainsKey("Battle Shout") && !StyxWoW.Me.Mounted)
                {
                    CastSpell("Battle Shout");
                    return true;
                }
                return false;
            }
        }
        #endregion

        #region Defensive CD's
        public bool DemoralizingShout()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.CurrentTarget.Distance <= 10d && !StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Demoralizing Shout"))
                {
                    CastSpell("Demoralizing Shout");
                    return true;
                }
                return false;
            }
        }
        public bool IntimidatingShout()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.Auras.ContainsKey("Defensive Stance") && StyxWoW.Me.HealthPercent <= AB_Settings.Instance.DO_IS)
                {
                    CastSpell("Intimidating Shout");
                    return true;
                }
                return false;
            }
        }
        public bool Retaliation()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.HealthPercent <= AB_Settings.Instance.DO_Retal)
                {
                    CastSpell("Retaliation");
                    return true;
                }
                return false;
            }
        }
        public bool ShieldBlock()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.Auras.ContainsKey("Defensive Stance") && StyxWoW.Me.HealthPercent <= AB_Settings.Instance.DO_SB)
                {
                    CastSpell("Shield Block");
                    return true;
                }
                return false;
            }
        }
        public bool ShieldWall()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.Auras.ContainsKey("Defensive Stance") && StyxWoW.Me.HealthPercent <= AB_Settings.Instance.DO_SW)
                {
                    CastSpell("Shield Wall");
                    return true;
                }
                return false;
            }
        }
        //Spell Refelect
        #endregion

        #region Health-Regeneration Abilities
        //Berserker Rage + Enraged Regeneration
        //Enraged Regeneration
        //Enraged Regeneration + Rallying Cry
        public bool RallyingCry()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.HealthPercent <= AB_Settings.Instance.SHO_RC)
                {
                    CastSpell("Rallying Cry");
                    return true;
                }
                return false;
            }
        }
        public bool VictoryRush()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.CurrentTarget.IsWithinMeleeRange && StyxWoW.Me.Auras.ContainsKey("Victorious") && StyxWoW.Me.HealthPercent <= AB_Settings.Instance.SHO_VR)
                {
                    CastSpell("Victory Rush");
                    return true;
                }
                return false;
            }
        }
        #endregion

        #region Interrupts
        //Arcane Torent
        public bool ISRupt()
        {
            using (new FrameLock())
            {
                if (AB_Settings.Instance.IO_IS && StyxWoW.Me.CurrentTarget.IsCasting && StyxWoW.Me.CanInterruptCurrentSpellCast &&
                    SpellManager.Spells["Pummel"].CooldownTimeLeft.TotalSeconds > 1 && StyxWoW.Me.CurrentTarget.Distance <= 8d)
                {
                    CastSpell("Intimidating Shout");
                    return true;
                }
                return false;
            }
        }
        public bool Pummel()
        {
            using (new FrameLock())
            {
                if (AB_Settings.Instance.IO_Pum && StyxWoW.Me.CurrentTarget.IsWithinMeleeRange && StyxWoW.Me.CurrentTarget.IsCasting && StyxWoW.Me.CanInterruptCurrentSpellCast)
                {
                    CastSpell("Pummel");
                    return true;
                }
                return false;
            }
        }
        public bool ThrowdownRupt()
        {
            using (new FrameLock())
            {
                if (AB_Settings.Instance.IO_TD && StyxWoW.Me.CurrentTarget.IsWithinMeleeRange && StyxWoW.Me.CurrentTarget.IsCasting && StyxWoW.Me.CanInterruptCurrentSpellCast &&
                    SpellManager.Spells["Pummel"].CooldownTimeLeft.TotalSeconds > 1 && SpellManager.Spells["Intimidating Shout"].CooldownTimeLeft.TotalSeconds > 1)
                {
                    CastSpell("Throwdown");
                    return true;
                }
                return false;
            }
        }
        #endregion

        #region IsTargetXXX
        public bool IsTargetBeingHealed()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") ||
                    StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") ||
                    StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") ||
                    StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") ||
                    StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") ||
                    StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey(""))
                    return true;
                return false;
            }
        }
        public bool IsTargetBoss()
        {
            using (new FrameLock())
            {
                if (!IsTargetDummy() && (StyxWoW.Me.CurrentTarget.CreatureRank == WoWUnitClassificationType.WorldBoss || (StyxWoW.Me.CurrentTarget.Level >= 85 &&
                    StyxWoW.Me.CurrentTarget.Elite)))
                    return true;
                return false;
            }
        }
        public bool IsTargetDummy()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.CurrentTarget.Name == "Training Dummy" || StyxWoW.Me.CurrentTarget.Name == "Raider's Training Dummy")
                    return true;
                return false;
            }
        }
        public bool IsTargetNPC()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.CurrentTarget.IsPlayer && (!StyxWoW.Me.CurrentTarget.IsFriendly || StyxWoW.Me.CurrentTarget.IsHostile || StyxWoW.Me.CurrentTarget.Attackable))
                    return true;
                return false;
            }
        }
        public bool IsTargetHealer()
        {
            using (new FrameLock())
            {
                if (((StyxWoW.Me.CurrentTarget.Class == WoWClass.Druid && !StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Moonkin Aura")) ||
                    StyxWoW.Me.CurrentTarget.Class == WoWClass.Paladin || (StyxWoW.Me.CurrentTarget.Class == WoWClass.Priest &&
                    !StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Shadowform")) || (StyxWoW.Me.CurrentTarget.Class == WoWClass.Shaman &&
                    !StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Elemental Oath"))) && StyxWoW.Me.CurrentTarget.MaxMana >= 100000)
                    return true;
                return false;
            }
        }
        public bool IsTargetVehicle()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.CurrentTarget.Name == "Battleground Demolisher" || StyxWoW.Me.CurrentTarget.Name == "Catapult" || StyxWoW.Me.CurrentTarget.Name == "Demolisher" ||
                    StyxWoW.Me.CurrentTarget.Name == "Glaive Thrower" || StyxWoW.Me.CurrentTarget.Name == "Siege Engine")
                    return true;
                return false;
            }
        }
        #endregion

        #region Let's Get Reacquainted
        public bool Charge()
        {
            using (new FrameLock())
            {
                if (AB_Settings.Instance.TOORO_C && (StyxWoW.Me.CurrentTarget.IsHostile || !StyxWoW.Me.CurrentTarget.IsFriendly || StyxWoW.Me.CurrentTarget.Attackable) &&
                    StyxWoW.Me.CurrentTarget.Distance >= 8d && StyxWoW.Me.CurrentTarget.Distance <= 30d)
                {
                    CastSpell("Charge");
                    return true;
                }
            }
            return false;
        }
        public bool HeroicLeap()
        {
            using (new FrameLock())
            {
                if (AB_Settings.Instance.TOORO_HL && (StyxWoW.Me.CurrentTarget.IsHostile || !StyxWoW.Me.CurrentTarget.IsFriendly || StyxWoW.Me.CurrentTarget.Attackable) &&
                    StyxWoW.Me.CurrentTarget.Distance >= 8d && StyxWoW.Me.CurrentTarget.Distance <= 40d && SpellManager.Spells["Charge"].CooldownTimeLeft.TotalSeconds > 0 &&
                    SpellManager.Spells["Charge"].CooldownTimeLeft.TotalSeconds < 8)
                {
                    SpellManager.Cast("Heroic Leap");
                    {
                        LegacySpellManager.ClickRemoteLocation(StyxWoW.Me.CurrentTarget.Location);
                        return true;
                    }
                }
            }
            return false;
        }
        public bool Intervene()
        {
            using (new FrameLock())
            {
                if (AB_Settings.Instance.TOORO_I && StyxWoW.Me.CurrentTarget.IsFriendly && StyxWoW.Me.CurrentTarget.Distance <= 25d)
                {
                    CastSpell("Intervene");
                    return true;
                }
            }
            return false;
        }
        #endregion

        #region PreCombat Buff
        public bool PreCombatBattleShout()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.Auras.ContainsKey("Battle Shout") && !StyxWoW.Me.Mounted)
                {
                    CastSpell("Battle Shout");
                    return true;
                }
                return false;
            }
        }
        public bool PreCombatBattleStance()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.Auras.ContainsKey("Battle Stance"))
                {
                    CastSpell("Battle Stance");
                    return true;
                }
                return false;
            }
        }
        public bool PreCombatWeaponCheck()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.Auras.ContainsKey("Battle Stance"))
                {
                    TwoHander();
                    return true;
                }
                return false;
            }
        }
        #endregion

        #region Slow'em Down
        public bool Hamstring()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.CurrentTarget.IsWithinMeleeRange && Slowable() && !StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Hamstring"))
                {
                    CastSpell("Hamstring");
                    return true;
                }
            }
            return false;
        }
        public bool PiercingHowl()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.CurrentTarget.IsWithinMeleeRange && StyxWoW.Me.CurrentTarget.Distance <= 15d && Slowable() && !StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Hamstring"))
                {
                    CastSpell("Piercing Howl");
                    return true;
                }
            }
            return false;
        }
        public bool Throwdown()
        {
            using (new FrameLock())
            {
                if (AB_Settings.Instance.MO_TD && StyxWoW.Me.Auras.ContainsKey("Battle Stance") && (StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Colossus Smash") &&
                    (StyxWoW.Me.ActiveAuras.ContainsKey("Slaughter") && StyxWoW.Me.Auras["Slaughter"].StackCount == 3)) ||
                    (StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Inner Focus") || StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Aura Mastery")))
                {
                    CastSpell("Throwdown");
                    return true;
                }
                return false;
            }
        }
        #endregion

        #region SpellCasting Methods
        public bool AmIFeared()
        {
            WoWAuraCollection Auras = ObjectManager.Me.GetAllAuras();
            using (new FrameLock())
            {
                foreach (WoWAura a in Auras)
                {
                    if (!a.IsHarmful)
                    {
                        continue;
                    }
                    if (a.Spell.Mechanic == WoWSpellMechanic.Fleeing)
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        public bool AmIRooted()
        {
            WoWAuraCollection Auras = ObjectManager.Me.GetAllAuras();
            using (new FrameLock())
            {
                foreach (WoWAura a in Auras)
                {
                    if (!a.IsHarmful)
                    {
                        continue;
                    }
                    if (a.Spell.Mechanic == WoWSpellMechanic.Rooted)
                    {
                        return true;
                    }
                }
                return false;
            }
        }
        private void CastSpell(string SpellName)
        {
            using (new FrameLock())
            {
                if (SpellManager.CanCast(SpellName))
                {
                    int Manual = Lua.GetReturnVal<int>("return Manual and 0 or 1", 0);
                    SpellManager.Cast(SpellName);
                    Logging.Write(Color.DarkOrange, "");
                    Logging.Write(Color.Aqua, "Target: " + StyxWoW.Me.CurrentTarget.Name + "");
                    Logging.Write(Color.Aqua, "Target's Distance: " + StyxWoW.Me.CurrentTarget.Distance + "");
                    Logging.Write(Color.Aqua, "Target's Health: " + StyxWoW.Me.CurrentTarget.HealthPercent + "%");
                    Logging.Write(Color.Aqua, "Rage Availiable: " + StyxWoW.Me.CurrentRage + "/" + StyxWoW.Me.MaxRage + "");
                    Logging.Write(Color.Aqua, "Casting: " + SpellName + "");
                    if (Manual == 1)
                    {
                        Logging.Write(Color.Red, "Automatic Mode Active");
                    }
                    Logging.Write(Color.DarkOrange, "");
                    Logging.Write(Color.DarkOrange, "=========================");
                    return;
                }
            }
        }
        private void CastSpell(string SpellName, WoWUnit OnTarget)
        {
            using (new FrameLock())
            {
                if (SpellManager.CanCast("SpellName", OnTarget))
                {
                    int Manual = Lua.GetReturnVal<int>("return Manual and 0 or 1", 0);
                    SpellManager.Cast(SpellName, OnTarget);
                    Logging.Write(Color.DarkOrange, "");
                    Logging.Write(Color.Aqua, "Target: " + StyxWoW.Me.CurrentTarget.Name + "");
                    Logging.Write(Color.Aqua, "Target's Distance: " + StyxWoW.Me.CurrentTarget.Distance + "");
                    Logging.Write(Color.Aqua, "Target's Health: " + StyxWoW.Me.CurrentTarget.HealthPercent + "%");
                    Logging.Write(Color.Aqua, "Rage Availiable: " + StyxWoW.Me.CurrentRage + "/" + StyxWoW.Me.MaxRage + "");
                    Logging.Write(Color.Aqua, "Casting: " + SpellName + "");
                    if (Manual == 1)
                    {
                        Logging.Write(Color.Red, "Automatic Mode Active");
                    }
                    Logging.Write(Color.DarkOrange, "");
                    Logging.Write(Color.DarkOrange, "=========================");
                    return;
                }
            }
        }
        public int CurrentAddCount()
        {
            using (new FrameLock())
            {
                List<WoWUnit> AddList = ObjectManager.GetObjectsOfType<WoWUnit>(false).FindAll(Unit => Unit.Guid != Me.Guid && Unit.IsTargetingMeOrPet && !Unit.IsFriendly &&
                    !Unit.IsTotem && !Unit.IsPet && Unit != Me.CurrentTarget && !Styx.Logic.Blacklist.Contains(Unit.Guid));
                return AddList.Count;
            }
        }
        private int DebuffTimeLeft(string spellName, WoWUnit unit)
        {
            using (new FrameLock())
            {
                if (unit.Auras.ContainsKey(spellName))
                {
                    var auras = unit.GetAllAuras();
                    foreach (var a in auras)
                    {
                        if (a.Name == spellName && a.CreatorGuid == StyxWoW.Me.Guid)
                        {
                            return a.TimeLeft.Seconds;
                        }
                    }
                }
                return 0;
            }
        }
        public void ResetMacro(string Which)
        {
            using (new FrameLock())
            {
                Lua.DoString(Which + " = 0;");
            }
        }
        public void ResetAllMacros()
        {
            using (new FrameLock())
            {
                ResetMacro("MultiCastFT");
                ResetMacro("MultiCastMT");
            }
        }
        String[] Immunes = { "Hand of Freedom", "Divine Shield", "Ice Block", "Hand of Protection" };
        public bool Slowable()
        {
            using (new FrameLock())
            {
                foreach (string spell in Immunes)
                {
                    if (StyxWoW.Me.CurrentTarget.HasAura(spell))
                    {
                        return false;
                    }
                }
                return true;
            }
        }
        #endregion

        #region Stance Dance
        public bool BattleStance()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.Auras.ContainsKey("Battle Stance") && (!StyxWoW.Me.CurrentTarget.Auras.ContainsKey("Rend") || (StyxWoW.Me.Auras.ContainsKey("Taste for Blood") ||
                    SpellManager.CanCast("Overpower")) && StyxWoW.Me.CurrentRage <= 75 && SpellManager.Spells["Mortal Strike"].CooldownTimeLeft.TotalSeconds >= 1.5))
                {
                    CastSpell("Battle Stance");
                    return true;
                }
                return false;
            }
        }
        public bool BerserkerStance()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.Auras.ContainsKey("Berserker Stance") && !StyxWoW.Me.Auras.ContainsKey("Taste for Blood") && DebuffTimeLeft("Rend", StyxWoW.Me.CurrentTarget) > 0
                    && StyxWoW.Me.CurrentRage <= 75)
                {
                    CastSpell("Berserker Stance");
                    return true;
                }
                return false;
            }
        }
        public bool MacroBattleStance()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.Auras.ContainsKey("Battle Stance"))
                {
                    CastSpell("Battle Stance");
                    return true;
                }
                return false;
            }
        }
        public bool MacroDefensiveStance()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.Auras.ContainsKey("Defensive Stance"))
                {
                    CastSpell("Defensive Stance");
                    return true;
                }
                return false;
            }
        }
        #endregion

        #region Start Auto Attack
        public bool AutoAttack()
        {
            using (new FrameLock())
            {
                if (!StyxWoW.Me.IsAutoAttacking && StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                {
                    StyxWoW.Me.ToggleAttack();
                    Logging.Write(Color.OrangeRed, ">> Commencing Auto Attack <<");
                    return true;
                }
                return false;
            }
        }
        #endregion

        #region Weapon Swap
        public string TwoHandItemName = "Ruthless Gladiator's Decapitator";//Insert the name of your 2H between the quotes
        public string MainHandItemName = "Ruthless Gladiator's Hacker";//Insert the name of your 1H between the quotes
        public string OffHandItemName = "Cataclysmic Gladiator's Shield Wall";//Insert the name of your shield between the quotes
        public bool TwoHander()
        {
            using (new FrameLock())
            {
                if ((StyxWoW.Me.Auras.ContainsKey("Battle Stance") || StyxWoW.Me.Auras.ContainsKey("Berserker Stance")) && StyxWoW.Me.Inventory.Equipped.OffHand != null)
                {
                    Lua.DoString("RunMacroText(\"/equipslot 16 " + TwoHandItemName + "\")");
                    return true;
                }
                return false;
            }
        }
        public bool OneHanderWithShield()
        {
            using (new FrameLock())
            {
                if (StyxWoW.Me.Auras.ContainsKey("Defensive Stance") && StyxWoW.Me.Inventory.Equipped.OffHand == null)
                {
                    Lua.DoString("RunMacroText(\"/equipslot 16 " + MainHandItemName + "\")");
                    Lua.DoString("RunMacroText(\"/equipslot 17 " + OffHandItemName + "\")");
                    return true;
                }
                return false;
            }
        }
        #endregion
    }
}
